# This file is part of 'Cut The Crap (CTC)'
# Copyright 1999-2000 Constantinos A. Kotsokalis <ckotso@cs.ntua.gr>
#
# CTC is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# CTC is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with CTC; see the file COPYING. If not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
#

import asyncore, socket, time
import client_sock

class listen_sock(asyncore.dispatcher):

	def __init__(self, config, errobj):
		self.config = config
		self.errobj = errobj
		self.create_socket(socket.AF_INET, socket.SOCK_STREAM)
		self.set_reuse_addr()
		self.bind(('', self.config.bind_port))
		self.listen(20)
		asyncore.loop(timeout = 5)


	def handle_accept(self):
		(conn, addr) = self.accept()
		if not self.config.no_logging:
			print "Connection from " + addr[0] + " at " + time.ctime(time.time())
		if not self.config.acl.is_allowed(addr[0]):
			conn.close()
			return
		s = client_sock.client_sock(conn, self.config, self.errobj)


	def writable(self):
		return 0


	def log(self, msg):
		pass


