# This file is part of 'Cut The Crap (CTC)'
# Copyright 1999-2000 Constantinos A. Kotsokalis <ckotso@cs.ntua.gr>
#
# CTC is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# CTC is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with CTC; see the file COPYING. If not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
#

import string

class noproxy:

	def __init__(self, errobj):
		self.nplist = []
		self.errobj = errobj


	def add(self, subnet):
		errobj = self.errobj

		if subnet in self.nplist:
			errobj.eprint(subnet + " is already in NOPROXY list!", None)
		else:
			self.nplist.append(subnet)


	def remove(self, subnet):
		errobj = self.errobj
		
		if not (subnet in self.nplist):
			errobj.eprint(subnet + " is not in NOPROXY list anyway!", None)
		else:
			self.nplist.remove(subnet)


	def no_proxy(self, IP):
		for subnet in self.nplist:
			if string.find(IP, subnet) == 0:
				return 1
			else:
				continue
		return 0

