# This file is part of 'Cut The Crap (CTC)'
# Copyright 1999-2000 Constantinos A. Kotsokalis <ckotso@cs.ntua.gr>
#
# CTC is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# CTC is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with CTC; see the file COPYING. If not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
#

import asyncore, socket, string, time
import mdebug

class server_sock(asyncore.dispatcher_with_send):

	debug = 0

	def __init__(self, host, ip, port, buff, cli):
		addr = (ip, port)
		self.host = host
		self.cli = cli
		self.errobj = cli.errobj
		self.config = cli.config
		self.close_by_client = 0
		self.prev_state = {}
		self.buffcount = 0

		sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		try:
			sock.connect(addr)
			asyncore.dispatcher_with_send.__init__(self, sock)
			mdebug.mdebug(0, "Server socket " + `self.socket` + " connecting to " + `addr` )
			mdebug.mdebug(0, "Server socket " + `self.socket` + " sending buff " + `addr` )
			self.send(buff)
			self.error_occured = 0
		except socket.error, msg:
			self.socket = 0
			if not ((ip == self.config.parent_proxy_ip) and (port == self.config.parent_proxy_port)):
				self.errobj.eprint("socket error: ", msg)
				errstr = string.replace(self.config.error_html_file, "%SERVER", host)
				errstr = string.replace(errstr, "%PORT", `port`)
				errstr = string.replace(errstr, "%ERROR", msg[0])
				errstr = string.replace(errstr, "%DATE", time.ctime(time.time()))
				errstr = """HTTP/1.0 200 OK
Content-type: text/html
Content-length: """ + `len(errstr)` + """

""" + errstr
				self.cli.push(errstr)
			self.error_occured = 1


	def handle_read(self):
		# Sometimes the socket is closed by the client, although there
		# are data pending. If recv() is called in this situation an
		# exception is thrown (bad file descriptor)
		if self.socket.fileno() == -1:
			return
		mdebug.mdebug(0, "Server socket " + `self.socket` + " going to read in data")
		buff = self.recv(4096)
		mdebug.mdebug(0, "Read buff: " + buff + "\n\n")
		mdebug.mdebug(0, "Read data")
		mdebug.mdebug(0, "(Before filters) Buffer was:\n" + buff)
		buff = self.apply_filters(self.host, buff)
		mdebug.mdebug(0, "Applied filters")
		if self.buffcount == 0:
			self.buffcount = 1
		mdebug.mdebug(0, "Changed buffcount")
		mdebug.mdebug(0, "(After filters) Buffer now is:\n" + buff)
		self.cli.push(buff)
		mdebug.mdebug(0, "Sent buff: " + buff + "\n\n")
		mdebug.mdebug(0, "Pushed data and returning")


	def handle_close(self):
		if not self.close_by_client:
			mdebug.mdebug(0, "handle_close() invoked for server socket " + `self.socket` + " by network engine")
			self.cli.slist.remove(self)
			mdebug.mdebug(0, "Server socket " + `self.socket` + " invoking srv_closed on " + `self.cli.socket`)
			self.cli.srv_closed()
		mdebug.mdebug(0, "Server socket " + `self.socket` + " shutting down")
		self.close()


	def apply_filters(self, host, allbuff):
		count = 0
		if self.buffcount == 0:
			ind = string.find(allbuff, "\r\n\r\n")
			header = allbuff[:ind+4]
			buff = allbuff[ind+4:]
		else:
			header = ''
			buff = allbuff
		for plugin in self.config.plugins:
			state = self.config.states[count]
			exec(plugin)
			self.config.states[count] = state
			count = count + 1
		mdebug.mdebug(0, "Header is: " + header)
		return header + buff


	def log(self, msg):
		pass



